<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>userDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
</head>
<style>
    .button {
        display: flex;
        justify-content: flex-end;
    }

    button {
        background-color: rgb(147, 147, 212);
        
        color: white;
        width: 120px;
        height: 40px;
    }
</style>

<body>
    <div class="container w-50">
        <div class="text-center m-3">
            <h3>THÔNG TIN CHI TIẾT NGƯỜI DÙNG</h3>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-user-id">Nhập Id của user <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-5">
                <input id="input-user-id" placeholder="Nhập id user ..." class="form-control">
            </div>
            <div class="col-sm-3">
                <button onclick="onBtnLayThongTinClick()" class="btn btn-primary">Lấy thông tin</button>
            </div>
        </div>
        <div class="row form-group">
            <div class="col-sm-12">Một số id user đúng để test: <span class="text-danger">172728, 172729, 172730,
                    181000, 172732, 172733, 172745</span></div>
        </div>

        <hr>

        <div class="row form-group mt-4">
            <label class="col-form-label col-sm-4" for="input-firstname">First name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input id="input-firstname" placeholder="First name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-lastname">Last name <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input id="input-lastname" placeholder="Last name" class="form-control">
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="input-subject">Subject <span
                    class="text-danger">(*)</span></label>
            <div class="col-sm-8">
                <input type="text" id="input-subject" placeholder="Subject" class="form-control">
            </div>
        </div>

        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-country">Country</label>
            <div class="col-sm-8">
                <select id="select-country" class="form-control">
                    <option value="VN">Việt Nam</option>
                    <option value="AUS">Australia</option>
                    <option value="USA">USA</option>
                    <option value="CAN">Canada</option>
                </select>
            </div>
        </div>

        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-customer-type">Customer Type</label>
            <div class="col-sm-8">
                <select id="select-customer-type" class="form-control">
                    <option value="Gold">Gold</option>
                    <option value="Premium">Premium</option>
                    <option value="Standard">Standard</option>
                </select>
            </div>
        </div>
        <div class="row form-group">
            <label class="col-form-label col-sm-4" for="select-register-status">Register Status</label>
            <div class="col-sm-8">
                <select id="select-register-status" class="form-control">
                    <option value="Accepted">Accepted</option>
                    <option value="Denied">Denied</option>
                    <option value="New">New</option>
                </select>
            </div>
        </div>
        <div class="button">
            <button onclick="onBtnUpdateUserClick()">Cập nhật User</button>
        </div>
    </div>
</body>
<script>
    "use strict"
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gUTF8_TEXT_APPLICATON_HEADER = "application/json;charset=UTF-8";

    /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //hàm xử lý sự kiện click nút lấy thông tin
    function onBtnLayThongTinClick() {
        //khai báo obj
        var vUserObj = {
            id: ""
        };
        //B1:Đọc dữ liệu
        thuThapDuLieu(vUserObj)
        //B2: Validate
        var vKiemTra = validateIDInput(vUserObj);
        if (vKiemTra) {
            //B3: Gọi API
            goiAPItheoID(vUserObj)
        }
    }
    //hàm xử lý sự kiện bấm nút cập nhật User
    function onBtnUpdateUserClick() {
        "use strict"
        var vUserObj = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: ""
        };
        //B1: thu thập dữ liệu trên form
        docDuLieuInput(vUserObj);
        //B2: Kiểm tra dữ liệu
        var vKetQuaKiemTra = validateData(vUserObj);
        if (vKetQuaKiemTra) {
            //B3: Gọi API
            var vXmlhttp = new XMLHttpRequest();
            callAPiUpdateDataUser(vUserObj, vXmlhttp);
            console.log(vXmlhttp.readyState);
            vXmlhttp.onreadystatechange = function () {
                if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                    console.log(this.responseText);
                    //B4:thông báo cập nhật thành công hay không
                    alert("Đã cập nhật thành công");
                }
            }
        }
        
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Hàm đọc dữ liệu
    function thuThapDuLieu(paramUserObj) {
        var vIdInput = document.getElementById("input-user-id");
        paramUserObj.id = vIdInput.value.trim();
    }
    //hàm validate dữ liệu
    function validateIDInput(paramUserObj) {
        //id user phải nhập
        if (paramUserObj.id == "") {
            alert("Phải nhập vào id User");
            return false;
        }
        return true;
    }
    //hàm gọi API
    function goiAPItheoID(paramUserObj) {
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", gBASE_URL + paramUserObj.id, false);
        vXmlHttp.send();

        var vStatusCode = vXmlHttp.status;
        // nếu trạng thái trả về thành công!
        if (vStatusCode == gREQUEST_STATUS_OK) {
            // nhận lại response dạng JSON ở xmlHttp.responseText và chuyển thành object
            console.log(vXmlHttp.responseText);
            //B4: hiển thị dữ liệu
            xuLyHienThi(vXmlHttp);
        }
        else {
            alert("Id nhập vào không tồn tại");
        }
    }
    //Hàm xử lý hiển thị
    function xuLyHienThi(paramXmlHttpObj) {
        var vUserObj = JSON.parse(paramXmlHttpObj.responseText);
        var vFirstName = document.getElementById("input-firstname");
        var vLastName = document.getElementById("input-lastname");
        var vSubject = document.getElementById("input-subject");
        var vCountry = document.getElementById("select-country");
        var vCustomerType = document.getElementById("select-customer-type");
        var vStatus = document.getElementById("select-register-status");

        vFirstName.value = vUserObj.firstname;
        vLastName.value = vUserObj.lastname;
        vSubject.value = vUserObj.subject;
        vCountry.value = vUserObj.country;
        vCustomerType.value = vUserObj.customerType;
        vStatus.value = vUserObj.registerStatus;
    }
    //Hàm đọc dữ liệu được điền vào trên form
    function docDuLieuInput(paramUserObj) {
        // var vId = document.getElementById("input-user-id");
        var vFirstName = document.getElementById("input-firstname");
        var vLastName = document.getElementById("input-lastname");
        var vSubject = document.getElementById("input-subject");
        var vCountry = document.getElementById("select-country");
        var vCustomerType = document.getElementById("select-customer-type");
        var vStatus = document.getElementById("select-register-status");

        // paramUserObj.id = vId.value.trim();
        paramUserObj.firstname = vFirstName.value.trim();
        paramUserObj.lastname = vLastName.value.trim();
        paramUserObj.subject = vSubject.value.trim();
        paramUserObj.country = vCountry.value;
        paramUserObj.customerType = vCustomerType.value;
        paramUserObj.registerStatus = vStatus.value;
    }
    //hàm kiểm tra dữ liệu người dùng nhập vào trên form
    function validateData(paramUserObj) {
        if (paramUserObj.id == "") {
            alert("Phải nhập id");
            return false;
        }
        if (paramUserObj.firstname == "") {
            alert("Phải nhập firstname");
            return false;
        }
        if (paramUserObj.lastname == "") {
            alert("Phải nhập lastname");
            return false;
        }
        if (paramUserObj.subject == "") {
            alert("Phải nhập subject");
            return false;
        }
        if (paramUserObj.country == "") {
            alert("Phải nhập country");

            return false;
        }
        if (paramUserObj.customertype == "") {
            alert("Phải nhập customerType");
            return false;
        }
        if (paramUserObj.status == "") {
            alert("Phải nhập registerStatus");
            return false;
        }
        return true;
    }
    //Gọi Api cập nhật thông tin người dùng
    function callAPiUpdateDataUser(paramUseObj, paramXmlHttp) {
        var vIdInput = document.getElementById("input-user-id");
        var vIdUser = vIdInput.value.trim();
        var vUserJSONObj = JSON.stringify(paramUseObj);
        paramXmlHttp.open("PUT", gBASE_URL + vIdUser , true);
        paramXmlHttp.setRequestHeader("Content-Type", gUTF8_TEXT_APPLICATON_HEADER);
        paramXmlHttp.send(vUserJSONObj);
    }
</script>

</html>